Eloqua Asynchronous Visitor Tracking
====================================

Overview
--------

Integration module for Eloqua Asynchronous Visitor Tracking. The module add the Eloqua tracking scripts to all pages on
the site. It also provide an helper function in PHP to push items in the \_elqQ JavaScript object
(`eloqua_tracking_push()`).

Configuration and usage
-----------------------

### Basic Page View Tracking

`$conf['eloqua_tracking_sites'] = array('site ID');`

### Basic Page View Tracking with First-Party Cookies

`$conf['eloqua_tracking_sites'] = array('tracking.mysite.com' => 'site ID');`

### Tracking to Multiple Eloqua Instances

`$conf['eloqua_tracking_sites'] = array('123', '456');`

### Tracking Custom URLs/Referrers

Implements hook_alter_eloqua_tracking_url(&$url, &$referer) in a custom module or theme .

### Outbound Link Tracking

*Not supported, please submit patch*

### Reposting Externally Hosted Forms

It is the form responsibility to include the require hidden inputs (`elqFormName`, `elqSiteId`, `elqCustomerGUID` and
`elqCookieWrite`). The module's JavaScript will insert the customer GUID in any `elqCustomerGUID` form input.

### Data Lookups

Data Lookups are provided as an optional library, see below.

### Strict Mode Tracking

*Not supported, please submit patch*

### Opting-In/Out

*Not supported, please submit patch*

Web Data Lookups
----------------

An optional JavaScript library is provided to help with Web Data Lookup. When used, JavaScript generated by the Eloqua
application can not be used in the page. Mixing both will cause serious breakage and unwanted results.

To use the library, it must be added as dependency of your own library defined with `hook_library()`, or inserted in the
page with `drupal_add_library('eloqua_tracking', 'datalookup')` or
`$element['#attached']['library'][] = array('eloqua_tracking', 'datalookup')`.

For usage, see the documentation of the `Drupal.Eloqua.DataLookup` constructor and the `Drupal.Eloqua.dataLookup`
function.